void RoboTumbler_Loop(){
  unsigned long currentMillis = millis();

  //--------------------------------------------------------------------------------------
  //  Встает с 12 часов
  //--------------------------------------------------------------------------------------
  // обновление таймера
  if (!goontop12){
    previousMillis12h = currentMillis;
  }
  if(currentMillis - previousMillis12h > 1000 && goontop12try < trys){ // Задержка до подъема манипулятора в исходное положение

    // Счетчик попыток
    if(try12){
      goontop12try ++;
      Serial.println(goontop12try);
      try12 = false;
    }

    // Подъем манипулятора в ИП после падения на 12 часов
    if (goontop12 && ArmDirection == 12){
      // Серво 2 до 90
      pos2temp = Servo2.read();
      if(currentMillis - previousMillis2 > 10){
        previousMillis2 = currentMillis;
        if (pos2temp < 90){
          pos2 = pos2temp + 1;
          Servo2.write(pos2);
        }
      }
      //------------------------

      if(Servo2.read() == 90){
        // Серво 3 до 90
        pos3temp = Servo3.read();
        if(currentMillis - previousMillis3 > 5){
          previousMillis3 = currentMillis;
          if (pos3temp > 90){
            pos3 = pos3temp - 1;
            Servo3.write(pos3);
          }
        }
        //------------------------
      }
      if(Servo3.read() == 90){
        // Серво 1 до 90
        pos1temp = Servo1.read();
        if(currentMillis - previousMillis1 > 5){
          previousMillis1 = currentMillis;
          if (pos1temp > 90){
            pos1 = pos1temp - 1;
            Servo1.write(pos1);
          }
        }
        //------------------------
      }
    }
  }

  //--------------------------------------------------------------------------------------
  //  Встает с 6 часов
  //--------------------------------------------------------------------------------------
  // обновление таймера
  if (!goontop6){
    previousMillis6h = currentMillis;
  }
  if(currentMillis - previousMillis6h > 1000 && goontop6try < trys){ // Задержка до подъема манипулятора в исходное положение

    // Счетчик попыток
    if(try6){
      goontop6try ++;
      Serial.println(goontop6try);
      try6 = false;
    }

    // Подъем манипулятора в ИП после падения на 6 часов  
    if (goontop6 && ArmDirection == 6){
      // Серво 2 до 90
      pos2temp = Servo2.read();
      //unsigned long currentMillis = millis();
      if(currentMillis - previousMillis2 > 10){
        previousMillis2 = currentMillis;
        if (pos2temp > 90){
          pos2 = pos2temp - 1;
          Servo2.write(pos2);
        }
      }
      //------------------------

      if(Servo2.read() == 90){
        // Серво 3 до 90
        pos3temp = Servo3.read();
        //unsigned long currentMillis = millis();
        if(currentMillis - previousMillis3 > 5){
          previousMillis3 = currentMillis;
          if (pos3temp < 90){
            pos3 = pos3temp + 1;
            Servo3.write(pos3);
          }
        }
        //------------------------
      }
      if(Servo3.read() == 90){
        // Серво 1 до 90
        pos1temp = Servo1.read();
        unsigned long currentMillis = millis();
        if(currentMillis - previousMillis1 > 5){
          previousMillis1 = currentMillis;
          if (pos1temp > 90){
            pos1 = pos1temp - 1;
            Servo1.write(pos1);
          }
        }
        //------------------------
      }
    }
  }

  //--------------------------------------------------------------------------------------
  //  Встает с 3 часов
  //--------------------------------------------------------------------------------------
  // обновление таймера
  if (!goontop3){
    previousMillis3h = currentMillis;
  }
  if(currentMillis - previousMillis3h > 1000 && goontop3try < trys){ // Задержка до подъема манипулятора в исходное положение

    // Счетчик попыток
    if(try3){
      goontop3try ++;
      Serial.println(goontop3try);
      try3 = false;
    }

    // Подъем манипулятора в ИП после падения на 12 часов
    if (goontop3 && ArmDirection == 3){
      // Серво 2 до 90
      pos2temp = Servo2.read();
      if(currentMillis - previousMillis2 > 10){
        previousMillis2 = currentMillis;
        if (pos2temp < 90){
          pos2 = pos2temp + 1;
          Servo2.write(pos2);
        }
      }
      //------------------------

      if(Servo2.read() == 90){
        // Серво 3 до 90
        pos3temp = Servo3.read();
        if(currentMillis - previousMillis3 > 5){
          previousMillis3 = currentMillis;
          if (pos3temp > 90){
            pos3 = pos3temp - 1;
            Servo3.write(pos3);
          }
        }
        //------------------------
      }
      if(Servo3.read() == 90){
        // Серво 1 до 90
        pos1temp = Servo1.read();
        if(currentMillis - previousMillis1 > 5){
          previousMillis1 = currentMillis;
          if (pos1temp > 90){
            pos1 = pos1temp - 1;
            Servo1.write(pos1);
          }
        }
        //------------------------
      }
    }
  }

  //--------------------------------------------------------------------------------------
  //  Встает с 9 часов
  //--------------------------------------------------------------------------------------
  // обновление таймера
  if (!goontop9){
    previousMillis9h = currentMillis;
  }
  if(currentMillis - previousMillis9h > 1000 && goontop9try < trys){ // Задержка до подъема манипулятора в исходное положение

    // Счетчик попыток
    if(try9){
      goontop9try ++;
      try9 = false;
    }

    // Подъем манипулятора в ИП после падения на 12 часов
    if (goontop9 && ArmDirection == 9){
      // Серво 2 до 90
      pos2temp = Servo2.read();
      if(currentMillis - previousMillis2 > 10){
        previousMillis2 = currentMillis;
        if (pos2temp > 90){
          pos2 = pos2temp - 1;
          Servo2.write(pos2);
        }
      }
      //------------------------

      if(Servo2.read() == 90){
        // Серво 3 до 90
        pos3temp = Servo3.read();
        if(currentMillis - previousMillis3 > 5){
          previousMillis3 = currentMillis;
          if (pos3temp < 90){
            pos3 = pos3temp + 1;
            Servo3.write(pos3);
          }
        }
        //------------------------
      }
      if(Servo3.read() == 90){
        // Серво 1 до 90
        pos1temp = Servo1.read();
        if(currentMillis - previousMillis1 > 5){
          previousMillis1 = currentMillis;
          if (pos1temp > 90){
            pos1 = pos1temp - 1;
            Servo1.write(pos1);
          }
        }
        //------------------------
      }
    }
  }

  //---------- Завершение подъемов ----------------
  if (Servo1.read() == 90 && Servo2.read() == 90 && Servo3.read() == 90 && goontop12try < trys){
    ArmDirection = 0;
    goontop6 = false;
    goontop12 = false;
    goontop3 = false;
    goontop9 = false;
    goontop12try = 0;
  }

  //--------------------------------------------------------------------------------------
  // Передвижение после 5 попыток
  //--------------------------------------------------------------------------------------  
  if (goontop12try == trys){ // на 12 часов
    Servo1.write(90);
    Servo2.write(90);
    Servo3.write(90);
    goontop12try = 0;
  }

  if (goontop6try == trys){ // на 6 часов
    Servo1.write(90);
    Servo2.write(90);
    Servo3.write(90);
    goontop6try = 0;
  }

  if (goontop3try == trys){ // на 3 часов
    Servo1.write(180);
    Servo2.write(90);
    Servo3.write(90);
    goontop3try = 0;
  }

  if (goontop9try == trys){ // на 9 часов
    Servo1.write(180);
    Servo2.write(90);
    Servo3.write(90);
    goontop9try = 0;
  }

  //--------------------------------------------------------------------------------------
  // Падение на 12 часов
  //--------------------------------------------------------------------------------------
  // Условия превышения угла
  if (TO_DEG(roll) > 0 && TO_DEG(roll) > 13 && TO_DEG(pitch) < 10 && goontop12try < trys){
    goto12 = true;
    goontop12 = false;
  }

  // Установка манипулятора в положение для падения на 12 часов
  if (goto12 && goto6 || goto12 && goto3 || goto12 && goto9 || goto12 && goontop6 || goto12 && goontop3 || goto12 && goontop9){
    goontop6 = false;
    goontop3 = false;
    goontop9 = false;
    goto12 = false;
    goto12temp = true;
  }

  if (goto12temp){
    Servo2.write(90);
    Servo3.write(90);
    if(Servo2.read() == 90 && Servo3.read() == 90){
      if (goto12temp && Servo1.read() == 180){
        goto6 = false;
        goto3 = false;
        goto9 = false;
        goto12 = true;
        goto12temp = false;
      }
      else{
        Servo1.write(90);
        if(Servo1.read() == 90){
          goto6 = false;
          goto3 = false;
          goto9 = false;
          goto12 = true;
          goto12temp = false;
        }
      }
    }
  }

  // Движение манипулятора при падении на 12 часов
  if (goto12){ 
    // Серво 1 до 180
    pos1temp = Servo1.read();
    unsigned long currentMillis = millis();
    if(currentMillis - previousMillis1 > 1){
      previousMillis1 = currentMillis;
      if (pos1temp < 180){
        pos1 = pos1temp + 1;
        Servo1.write(pos1);
      }
    }
    //------------------------

    if (Servo1.read() == 180){
      // Серво 2 до 0
      pos2temp = Servo2.read();
      //unsigned long currentMillis = millis();
      if(currentMillis - previousMillis2 > 3){
        previousMillis2 = currentMillis;
        if (pos2temp > 0){
          pos2 = pos2temp - 1;
          Servo2.write(pos2);
        }
      }
      //------------------------

      // Серво 3 до 180
      pos3temp = Servo3.read();
      //unsigned long currentMillis = millis();
      if(currentMillis - previousMillis3 > 3){
        previousMillis3 = currentMillis;
        if (pos3temp < 180){
          pos3 = pos3temp + 1;
          Servo3.write(pos3);
        }
      }
      //------------------------
    }
  }

  // Завершение падения
  if (Servo1.read() == 180 && Servo2.read() == 0 && Servo3.read() == 180){
    ArmDirection = 12;
    goto12 = false;
    goontop12 = true;
    try12 = true;
  }

  //--------------------------------------------------------------------------------------
  //  Падение на 6 часов
  //--------------------------------------------------------------------------------------
  // Условия превышения угла
  if (TO_DEG(roll) < 0 && TO_DEG(roll) < -13 && TO_DEG(pitch) > -10 && goontop6try < trys){
    goto6 = true;
    goontop6 = false;
  }

  // Установка манипулятора в положение для падения
  if (goto6 && goto12 || goto6 && goto3 || goto6 && goto9 || goto6 && goontop12 || goto6 && goontop3 || goto6 && goontop9){
    goontop12 = false;
    goontop3 = false;
    goontop9 = false;
    goto6 = false;
    goto6temp = true;
  }

  if (goto6temp){
    Servo2.write(90);
    Servo3.write(90);
    if(Servo2.read() == 90 && Servo3.read() == 90){
      if (goto6temp && Servo1.read() == 180){
        goto12 = false;
        goto3 = false;
        goto9 = false;
        goto6 = true;
        goto6temp = false;
      }
      else{
        Servo1.write(90);
        if(Servo1.read() == 90){
          goto12 = false;
          goto3 = false;
          goto9 = false;
          goto6 = true;
          goto6temp = false;
        } 
      }
    }
  }

  // Движение манипулятора при падении на 6 часов
  if (goto6){ 
    // Серво 1 до 180
    pos1temp = Servo1.read();
    unsigned long currentMillis = millis();
    if(currentMillis - previousMillis1 > 1){
      previousMillis1 = currentMillis;
      if (pos1temp < 180){
        pos1 = pos1temp + 1;
        Servo1.write(pos1);
      }
    }
    //------------------------

    if (Servo1.read() == 180){
      // Серво 2 до 180
      pos2temp = Servo2.read();
      //unsigned long currentMillis = millis();
      if(currentMillis - previousMillis2 > 3){
        previousMillis2 = currentMillis;
        if (pos2temp < 180){
          pos2 = pos2temp + 1;
          Servo2.write(pos2);
        }
      }
      //------------------------

      // Серво 3 до 0
      pos3temp = Servo3.read();
      if(currentMillis - previousMillis3 > 3){
        previousMillis3 = currentMillis;
        if (pos3temp > 0){
          pos3 = pos3temp - 1;
          Servo3.write(pos3);
        }
      }
      //------------------------
    }
  }

  // Завершение падения
  if (Servo1.read() == 180 && Servo2.read() == 180 && Servo3.read() == 0){
    ArmDirection = 6;
    goto6 = false;
    goontop6 = true;
    try6 = true;
  }

  //--------------------------------------------------------------------------------------
  // Падение на 3 часов
  //--------------------------------------------------------------------------------------
  // Условия превышения угла
  if (TO_DEG(pitch) > 0 && TO_DEG(pitch) > 13 && goontop3try < trys){
    goto3 = true;
    goontop3 = false;
  }

  // Установка манипулятора в положение для падения
  if (goto3 && goto12 || goto3 && goto6 || goto3 && goto9 || goto3 && goontop12 || goto3 && goontop6 || goto3 && goontop9){
    goontop6 = false;
    goontop12 = false;
    goontop9 = false;
    goto3 = false;
    goto3temp = true;
  }

  if (goto3temp){
    Servo2.write(90);
    Servo3.write(90);
    if(Servo2.read() == 90 && Servo3.read() == 90){
      if (goto3temp && Servo1.read() == 90){
        goto12 = false;
        goto6 = false;
        goto9 = false;
        goto3 = true;
        goto3temp = false;
      }
      else{
        Servo1.write(90);
        if(Servo1.read() == 90){
          goto12 = false;
          goto6 = false;
          goto9 = false;
          goto3 = true;
          goto3temp = false;
        }
      }
    }
  }

  // Движение манипулятора при падении на 3 часа
  if (goto3){
    // Серво 1 до 90
    pos1temp = Servo1.read();
    if(currentMillis - previousMillis1 > 1){
      previousMillis1 = currentMillis;
      if (pos1temp > 90){
        pos1 = pos1temp - 1;
        Servo1.write(pos1);
      }
    }
    //------------------------

    if (Servo1.read() == 90){
      // Серво 2 до 0
      pos2temp = Servo2.read();
      //unsigned long currentMillis = millis();
      if(currentMillis - previousMillis2 > 3){
        previousMillis2 = currentMillis;
        if (pos2temp > 0){
          pos2 = pos2temp - 1;
          Servo2.write(pos2);
        }
      }
      //------------------------

      // Серво 3 до 180
      pos3temp = Servo3.read();
      //unsigned long currentMillis = millis();
      if(currentMillis - previousMillis3 > 3){
        previousMillis3 = currentMillis;
        if (pos3temp < 180){
          pos3 = pos3temp + 1;
          Servo3.write(pos3);
        }
      }
      //------------------------
    }
  }

  // Завершение падения
  if (Servo1.read() == 90 && Servo2.read() == 0 && Servo3.read() == 180){
    ArmDirection = 3;
    goto3 = false;
    goontop3 = true;
    try3 = true;
  }

  //--------------------------------------------------------------------------------------
  // Падение на 9 часов
  //--------------------------------------------------------------------------------------
  // Условия превышения угла
  if (TO_DEG(pitch) < 0 && TO_DEG(pitch) < -13 && goontop9try < trys){
    goto9 = true;
    goontop9 = false;
  }

  // Установка манипулятора в положение для падения
  if (goto9 && goto12 || goto9 && goto6 || goto9 && goto3 || goto9 && goontop12 || goto9 && goontop6 || goto9 && goontop3){
    goontop6 = false;
    goontop12 = false;
    goontop3 = false;
    goto9 = false;
    goto9temp = true;
  }

  if (goto9temp){
    Servo2.write(90);
    Servo3.write(90);
    if(Servo2.read() == 90 && Servo3.read() == 90){
      if (goto9temp && Servo1.read() == 90){
        goto12 = false;
        goto6 = false;
        goto3 = false;
        goto9 = true;
        goto9temp = false;
      }
      else{
        Servo1.write(90);
        if(Servo1.read() == 90){
          goto12 = false;
          goto6 = false;
          goto3 = false;
          goto9 = true;
          goto9temp = false;
        }
      }
    }
  }

  // Движение манипулятора при падении на 9 часов
  if (goto9){
    // Серво 1 до 90
    pos1temp = Servo1.read();
    if(currentMillis - previousMillis1 > 1){
      previousMillis1 = currentMillis;
      if (pos1temp > 90){
        pos1 = pos1temp - 1;
        Servo1.write(pos1);
      }
    }
    //------------------------

    if (Servo1.read() == 90){
      // Серво 2 до 180
      pos2temp = Servo2.read();
      //unsigned long currentMillis = millis();
      if(currentMillis - previousMillis2 > 3){
        previousMillis2 = currentMillis;
        if (pos2temp < 180){
          pos2 = pos2temp + 1;
          Servo2.write(pos2);
        }
      }
      //------------------------

      // Серво 3 до 0
      pos3temp = Servo3.read();
      //unsigned long currentMillis = millis();
      if(currentMillis - previousMillis3 > 3){
        previousMillis3 = currentMillis;
        if (pos3temp > 0){
          pos3 = pos3temp - 1;
          Servo3.write(pos3);
        }
      }
      //------------------------
    }
  }

  // Завершение падения
  if (Servo1.read() == 90 && Servo2.read() == 180 && Servo3.read() == 0){
    ArmDirection = 9;
    goto9 = false;
    goontop9 = true;
    try9 = true;
  }

} //end

